decidim-admin/config/routes.rb
# frozen_string_literal: true

Decidim::Admin::Engine.routes.draw do
  constraints(->(request) { Decidim::Admin::OrganizationDashboardConstraint.new(request).matches? }) do
    resource :organization, only: [:edit, :update], controller: "organization" do
      resource :appearance, only: [:edit, :update], controller: "organization_appearance"
      resource :homepage, only: [:edit, :update], controller: "organization_homepage" do
        resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "organization_homepage_content_blocks"
      end
      resource :external_domain_allowlist, only: [:edit, :update], controller: "organization_external_domain_allowlist"

      member do
        get :users
      end
    end

    resources :static_pages do
      put :update_content_blocks, on: :member
      resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "static_page_content_blocks"
    end
    resources :static_page_topics
    resources :scope_types, except: [:show]
    resources :scopes, except: [:show] do
      resources :scopes, except: [:show]
    end
    resources :metrics, only: [:index]
    resources :logs, only: [:index]
    resources :area_types, except: [:show]
    resources :areas, except: [:show]

    resources :authorization_workflows, only: :index

    resources :users, except: [:edit, :update], controller: "users" do
      member do
        post :resend_invitation, to: "users#resend_invitation"
      end
    end

    resources :officializations, only: [:new, :create, :index, :destroy], param: :user_id do
      member do
        get :show_email
      end
    end

    resources :moderated_users, only: [:index] do
      member do
        put :ignore
      end
      collection do
        scope "/:user_id" do
          resource :user_block, only: [:new, :create, :destroy], controller: :block_user
        end
        post :bulk_new, controller: :block_user
        post :bulk_create, controller: :block_user
        delete :bulk_destroy, controller: :block_user
        patch :bulk_unreport, controller: :moderated_users
      end
    end

    resources :impersonatable_users, only: [:index] do
      resources :promotions, controller: "managed_users/promotions", only: [:new, :create]
      resources :impersonation_logs, controller: "managed_users/impersonation_logs", only: [:index]
      resources :impersonations, controller: "impersonations", only: [:new, :create] do
        collection do
          post :close_session
        end
      end
    end

    resources :newsletter_templates, only: [:index, :show] do
      resources :newsletters, only: [:new, :create]

      member do
        get :preview
      end
    end

    resources :newsletters, except: [:new, :create] do
      member do
        post :recipients_count
        post :send_to_user
        get :preview
        get :select_recipients_to_deliver
        post :deliver
        get :confirm_recipients
      end
    end

    resource :help_sections, only: [:show, :update]

    namespace :admin_terms do
      get :show
      put :accept
    end

    resources :moderations, controller: "global_moderations" do
      member do
        put :unreport
        put :hide
        put :unhide
      end
      patch :bulk_action, on: :collection
      resources :reports, controller: "global_moderations/reports", only: [:index, :show]
    end

    resources :conflicts, only: [:index, :edit, :update], controller: "conflicts"

    resources :taxonomies, except: [:show] do
      patch :reorder, on: :collection
      resources :items, only: [:new, :create, :edit, :update], controller: "taxonomy_items"
      resources :filters, except: [:show], controller: "taxonomy_filters"
    end
    resources :taxonomy_filters_selector, param: :taxonomy_filter_id, except: [:edit, :update]

    root to: "dashboard#show"
  end
end

decidim-admin/app/controllers/decidim/admin/block_user_controller.rb
# frozen_string_literal: true

module Decidim
  module Admin
    class BlockUserController < Decidim::Admin::ApplicationController
      layout "decidim/admin/global_moderations"

      helper_method :user

      def new
        enforce_permission_to :block, :admin_user

        @form = form(BlockUserForm).from_model(user)
        @form.hide = params[:hide] || false
      end

      def create
        enforce_permission_to :block, :admin_user

        @form = form(BlockUserForm).from_params(params)

        BlockUser.call(@form) do
          on(:ok) do
            flash[:notice] = I18n.t("officializations.block.success", scope: "decidim.admin")
            redirect_to moderated_users_path, notice:
          end

          on(:invalid) do
            flash[:alert] = I18n.t("officializations.block.error", scope: "decidim.admin")
            render :new
          end
        end
      end

      def destroy
        enforce_permission_to :block, :admin_user

        UnblockUser.call(user, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("officializations.unblock.success", scope: "decidim.admin")
          end

          on(:invalid) do
            flash[:alert] = I18n.t("officializations.unblock.error", scope: "decidim.admin")
          end
        end

        redirect_to moderated_users_path, notice:
      end

      def bulk_new
        enforce_permission_to :block, :admin_user

        @form = form(BlockUsersForm).from_params(params)
      end

      def bulk_create
        @form = form(BlockUsersForm).from_params(params)

        Admin::BulkBlockUsers.call(@form) do
          on(:ok) do
            flash[:notice] = I18n.t("officializations.bulk_action.block.success", scope: "decidim.admin")
            redirect_to moderated_users_path
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("officializations.bulk_action.block.invalid", scope: "decidim.admin")
            render :bulk_new
          end
        end
      end

      def bulk_destroy
        Admin::BulkUnblockUsers.call(blocked_users, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("officializations.bulk_action.unblock.success", scope: "decidim.admin")
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("officializations.bulk_action.unblock.invalid", scope: "decidim.admin")
          end
        end
        redirect_to moderated_users_path
      end

      private

      def user
        @user ||= Decidim::UserBaseEntity.find_by(
          id: params[:user_id],
          organization: current_organization
        )
      end

      def blocked_users
        @blocked_users ||= Decidim::UserBaseEntity.where(
          id: params[:user_ids],
          organization: current_organization
        )
      end
    end
  end
end

decidim-admin/app/views/decidim/admin/block_user/bulk_new.html.erb
<% add_decidim_page_title(t(".title")) %>
<div class="item_show__header">
  <h1 class="item_show__header-title">
    <%= t(".title") %>
  </h1>
</div>

<div class="item__edit item__edit-1col">
  <div class="item__edit-form">
    <%= decidim_form_for(@form, url: bulk_create_moderated_users_path, method: :post, html: { class: "form-defaults form import_participatory_process" }) do |f| %>
      <div class="form__wrapper">
        <div class="card pt-4">
          <div class="card-section">
            <div class="row column">
              <%= t(".description") %>
            </div>

            <% if @form.hide %>
              <%= cell("decidim/announcement", t(".already_reported_html"), callout_class: "alert" ) %>
            <% end %>

            <% if Decidim.module_installed?(:templates) %>
              <%= render "decidim/templates/admin/block_user_templates/template_chooser", form: f %>
            <% end %>

            <div class="row column">

              <% @form.user_ids.each do |id| %>
                <%= hidden_field_tag "user_ids[]", id %>
              <% end %>
              <%= f.hidden_field :hide %>
              <%= f.text_area :justification, required: true, label: t(".justification") %>
            </div>
          </div>
        </div>
      </div>

      <div class="item__edit-sticky">
        <div class="item__edit-sticky-container">
          <%= f.submit t(".action"), class: "button button__sm button__secondary" %>
        </div>
      </div>
    <% end %>
  </div>
</div>

decidim-admin/app/views/decidim/admin/block_user/new.html.erb
<% add_decidim_page_title(t(".title", name: user.name)) %>
<div class="item_show__header">
  <h1 class="item_show__header-title">
    <%= t(".title", name: user.name) %>
  </h1>
</div>

<div class="item__edit item__edit-1col">
  <div class="item__edit-form">
    <%= decidim_form_for(@form, url: user_block_path(user_id: user.id), method: :post, html: { class: "form-defaults form import_participatory_process" }) do |f| %>
      <div class="form__wrapper">
        <div class="card pt-4">
          <div class="card-section">
            <div class="row column">
              <%= t(".description") %>
            </div>

            <% if @form.hide %>
              <%= cell("decidim/announcement", t(".already_reported_html"), callout_class: "alert" ) %>
            <% end %>

            <% if Decidim.module_installed?(:templates) %>
              <%= render "decidim/templates/admin/block_user_templates/template_chooser", form: f %>
            <% end %>

            <div class="row column">
              <%= f.hidden_field :user_id %>
              <%= f.hidden_field :hide %>
              <%= f.text_area :justification, required: true, label: t(".justification") %>
            </div>
          </div>
        </div>
      </div>

      <div class="item__edit-sticky">
        <div class="item__edit-sticky-container">
          <%= f.submit t(".action"), class: "button button__sm button__secondary" %>
        </div>
      </div>
    <% end %>
  </div>
</div>